library picpay_payment_button;

import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:picpay_payment_button/src/picpay_payment_data.dart';
import 'package:picpay_payment_button/src/picpay_settings.dart';
import 'package:http/http.dart' as http;
export 'package:picpay_payment_button/src/picpay_payment_data.dart';
export 'package:picpay_payment_button/src/picpay_settings.dart';

class PaymentButton extends StatefulWidget {
  final Widget custom;
  final PicPaySettings settings;
  final PicPayPaymentRequest paymentRequest;
  final Function(Map) onResponse;
  final Function(Map) onSuccess;
  final Function(Map) onError;

  PaymentButton(
      {this.settings,
      this.custom,
      this.onResponse,
      this.onSuccess,
      this.onError,
      this.paymentRequest})
      : assert(settings != null),
        assert(paymentRequest != null);

  @override
  _PaymentButtonState createState() => _PaymentButtonState();
}

class _PaymentButtonState extends State<PaymentButton> {
  @override
  Widget build(BuildContext context) {
    if (widget.custom != null) return widget.custom;
    return Container(
      height: 40,
      decoration: BoxDecoration(
          color: Color(0xff21c25e),
          borderRadius: BorderRadius.all(Radius.circular(5))),
      child: RawMaterialButton(
        onPressed: () async {
          final response = await http.post(
              'https://appws.picpay.com/ecommerce/public/payments',
              headers: {
                'Content-Type': 'application/json',
                'x-picpay-token': widget.settings.xPicPayToken
              },
              body: json.encode(widget.paymentRequest.toJson()));

          final data = json.decode(utf8.decode(response.bodyBytes)) as Map;

          if (response.statusCode == 200) {
            if (widget.onSuccess == null) return;
            widget.onSuccess.call(data);
          } else {
            if (widget.onSuccess == null) return;
            widget.onSuccess.call(data);
          }
        },
        child: Text('Pagar com PicPay'),
      ),
    );
  }
}

/// A Calculator.
class Calculator {
  /// Returns [value] plus 1.
  int addOne(int value) => value + 1;
}
