import 'package:picpay_payment_button/src/picpay_buyer.dart';

class PicPayPaymentRequest {
  String referenceId;
  String callbackUrl;
  String returnUrl;
  double value;
  String expiresAt;
  PicPayBuyer buyer;

  PicPayPaymentRequest(
      {this.referenceId,
      this.callbackUrl,
      this.returnUrl,
      this.value,
      this.expiresAt,
      this.buyer});

  PicPayPaymentRequest.fromJson(Map<String, dynamic> json) {
    referenceId = json['referenceId'];
    callbackUrl = json['callbackUrl'];
    returnUrl = json['returnUrl'];
    value = json['value'];
    expiresAt = json['expiresAt'];
    buyer =
        json['buyer'] != null ? new PicPayBuyer.fromJson(json['buyer']) : null;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['referenceId'] = this.referenceId;
    data['callbackUrl'] = this.callbackUrl;
    data['returnUrl'] = this.returnUrl;
    data['value'] = this.value;
    data['expiresAt'] = this.expiresAt;
    if (this.buyer != null) {
      data['buyer'] = this.buyer.toJson();
    }
    return data;
  }
}
